package de.bsvrz.vew.bmvew.bmvew.regel;

import de.bsvrz.dav.daf.main.Data;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.Data.Array;
import de.bsvrz.dav.daf.main.Data.TextArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.config.AttributeGroup;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.vew.bmvew.bmvew.BetriebsMeldungApp;
import de.bsvrz.vew.bmvew.bmvew.plugin.StandardAktionen;

/**
 * Die Klasse implementiert das Ausfuehr-Verhalten erweitert 
 *
 * @version $Revision: 1.1 $ / $Date: 2009/09/24 12:50:46 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class AusfuehrenErweitert implements AktionAusfuehrVerhalten
{
  /**
   * Der Debugger
   */
  Debug _debug;
  
  /**
   * Das Feld der Parametertexte
   */
  TextArray _parameter;

  /**
   * Der Aktionstext
   */
  TextValue _aktion;

  /**
   * Konstruktor
   * 
   * @param parameter
   *          Feld der Parametertexte
   * @param aktion
   *          Aktionstext
   * 
   */
  public AusfuehrenErweitert(TextArray parameter, TextValue aktion)
  {
    // TODO Auto-generated constructor stub
    if (aktion == null || parameter == null)
      throw new IllegalArgumentException();
    
    _parameter = parameter;
    _aktion = aktion;
    _debug = Debug.getLogger();
  }

  /* (non-Javadoc)
   * @see de.bsvrz.vew.bmvew.bmvew.regel.AktionAusfuehrVerhalten#ausfuehrenAktion(de.bsvrz.dav.daf.main.ResultData)
   */
  public boolean ausfuehrenAktion(ResultData betriebsMeldung)
  {
    // TODO Auto-generated method stub
    TextValue aktionPlugin;

    TextArray parameterPlugin;

    String pluginPackage = null;

    AttributeGroup atg = BetriebsMeldungApp.getConnection().getDataModel().getAttributeGroup(
        "atg.betriebsMeldungsVerwaltungRegel");
    Data data = BetriebsMeldungApp.getConnection().createData(atg);

    Array a1 = data.getArray("Regel");
    a1.setLength(1);
    Array a2 = a1.getItem(0).getArray("Aktion");
    a2.setLength(1);
    //Data d1 = a2.getItem(0).getItem("Aktion");
    Data d1 = a2.getItem(0);

    parameterPlugin = d1.getItem("Parameter").asTextArray();
    parameterPlugin.setLength(_parameter.getLength() - 2);

    aktionPlugin = d1.getItem("Aktion").asTextValue();

    for (int i = 0; i < _parameter.getLength(); i++)
    {
      String text = _parameter.getText(i);

      if (i == 0)
      {
        pluginPackage = text;
      }
      else if (i == 1)
      {
        aktionPlugin.setText(text);
      }
      else
      {
        parameterPlugin.getTextValue(i - 2).setText(text);
      }

    }

    try
    {
      Class<?> klass = Class.forName(pluginPackage);

      try
      {
        StandardAktionen aktionenPlugin = (StandardAktionen)klass.newInstance();

        aktionenPlugin.initialisiere(aktionPlugin, parameterPlugin);

        if (aktionenPlugin.ausfuehre(betriebsMeldung))
          return true;
        else
          return false;
      }
      catch (InstantiationException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }
      catch (IllegalAccessException e)
      {
        // TODO Auto-generated catch block
        e.printStackTrace();
      }

    }
    catch (ClassNotFoundException e)
    {
      e.printStackTrace();
    }

    return false;
  }

}
