package de.bsvrz.vew.bmvew.bmvew.regel;

import java.util.ArrayList;
import java.util.List;

import de.bsvrz.dav.daf.main.DataNotSubscribedException;
import de.bsvrz.dav.daf.main.ResultData;
import de.bsvrz.dav.daf.main.SendSubscriptionNotConfirmed;
import de.bsvrz.dav.daf.main.Data.TextArray;
import de.bsvrz.dav.daf.main.Data.TextValue;
import de.bsvrz.dav.daf.main.config.ClientApplication;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.sys.funclib.debug.Debug;
import de.bsvrz.sys.funclib.operatingMessage.MessageCauser;
import de.bsvrz.sys.funclib.operatingMessage.MessageGrade;
import de.bsvrz.sys.funclib.operatingMessage.MessageSender;
import de.bsvrz.sys.funclib.operatingMessage.MessageState;
import de.bsvrz.sys.funclib.operatingMessage.MessageType;
import de.bsvrz.vew.bmvew.bmvew.BetriebsMeldungApp;

/**
 * Die Klasse implementiert das Ausfuehr-Verhalten Verteilen 
 *
 * @version $Revision: 1.1 $ / $Date: 2009/09/24 12:50:46 $ / ($Author: Pittner $)
 *
 * @author Dambach-Werke GmbH
 * @author Timo Pittner
 *
 */
public class AusfuehrenVerteilen implements AktionAusfuehrVerhalten 
{

  /**
   * Der Debugger
   */
  Debug _debug;
  
  /**
   * Das Feld der Parametertexte
   */  
  TextArray _parameter;
  
  /**
   * Der Aktionstext
   */
  TextValue _aktion; 
  
  /**
   * Der Aktionstext
   */
  List _fehlerInfoKanal; 
  
  /**
   * Konstruktor
   * 
   * @param parameter
   *          Feld der Parametertexte
   * @param aktion
   *          Aktionstext
   */
  public AusfuehrenVerteilen(TextArray parameter, TextValue aktion)
  {
    // TODO Auto-generated constructor stub
    if (aktion == null || parameter == null)
      throw new IllegalArgumentException();
    
    _parameter = parameter;
    _aktion = aktion;
    _debug = Debug.getLogger();
    _fehlerInfoKanal = new ArrayList();
  }

  /* (non-Javadoc)
   * @see de.bsvrz.vew.bmvew.bmvew.regel.AktionAusfuehrVerhalten#ausfuehrenAktion(de.bsvrz.dav.daf.main.ResultData)
   */
  public boolean ausfuehrenAktion(ResultData betriebsMeldung)
  {
    // TODO Auto-generated method stub
    for (int i = 0; i < _parameter.getLength(); i++)
    {
      String text = _parameter.getText(i);

      SystemObject so = BetriebsMeldungApp.getConnection().getDataModel().getObject(text);

      if (so != null)
      {
        ResultData resultData = new ResultData(so, betriebsMeldung.getDataDescription(), betriebsMeldung
            .getDataTime(), betriebsMeldung.getData());
        
        _debug.fine("Aktion Verteilen: " + resultData);
        
        try
        {
          _debug.fine("Aktion -> " + _aktion.getText() + " sende an Informationskanal: " + so.getPid());
          BetriebsMeldungApp.getConnection().sendData(resultData);
        }
        catch (DataNotSubscribedException e)
        {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }
        catch (SendSubscriptionNotConfirmed e)
        {
          // TODO Auto-generated catch block
          e.printStackTrace();
        }
      }else{
        
        _debug.error("Aktion -> " + _aktion.getText() +  " kein Informationskanal: " + text);
        
        ClientApplication app = BetriebsMeldungApp.getConnection().getLocalApplicationObject();

        SystemObject user = BetriebsMeldungApp.getConnection().getDataModel().getObject("");
        MessageCauser causer = new MessageCauser(user, "Fehler Aktion: Verteilen", app.getName());
        MessageSender instance = MessageSender.getInstance();

        instance.setApplicationLabel(app.getName());

        Long id = app.getId();        
        
        if (!_fehlerInfoKanal.contains(text)){
        
          instance.sendMessage(id.toString(), 
              MessageType.SYSTEM_DOMAIN, 
              "", 
              MessageGrade.ERROR,
              (SystemObject)BetriebsMeldungApp.getKonfigurationsObjekt(), 
              MessageState.NEW_MESSAGE, 
              causer,
              "Informationskanal nicht vorhanden: " + text);
            
          _fehlerInfoKanal.add(text);
          
        }
        
        
      }
    }
    
    return false;
  }

}
